{*
 MagKat application
}
program MagKat;

uses
  Forms,
  TConfiguratorUnit,
  SysUtils,
  fMagKatMain in 'fMagKatMain.pas' {frmMagKat},
  cMagKatBroker in 'cMagKatBroker.pas',
  cMagKatUtils in 'cMagKatUtils.pas',
  cMagKatEngine in 'cMagKatEngine.pas',
  cMagSecurity in 'cMagSecurity.pas',
  MagFileVersion in 'MagFileVersion.pas',
  fMagAbout in 'fMagAbout.pas' {frmAbout},
  uMagCRC32 in 'uMagCRC32.PAS',
  cMagListView in 'cMagListView.pas',
  cMagKatJukeboxFileEngine in 'cMagKatJukeboxFileEngine.pas',
  cMagKatPlatter in 'cMagKatPlatter.pas',
  fMagKatPlatterReport in 'fMagKatPlatterReport.pas' {frmPlatterReport},
  fMagSelectDb in 'fMagSelectDb.pas' {frmSelectDB};

{$R *.res}
var
  /// holds the current directory to write log files to
  logsDir : string;
  logfName : string;
begin
  Application.Initialize;
  // need to create the logs directory here so Log4Delphi can create the log files
  logsDir := cMagKatUtils.GetAppPath() + '\logs';
  if not DirectoryExists(logsDir) then
  begin
    ForceDirectories(logsDir);
  end;
  logfName := logsDir + '\MagKatInfo.log';
  cMagKatUtils.CreateIfNeeded(logfName);
  logfName := logsDir + '\MagKatError.log';
  cMagKatUtils.CreateIfNeeded(logfName);

  TConfiguratorUnit.doPropertiesConfiguration(ExtractFileDir(Application.ExeName)
   + '\MagKatLogging.properties');
  Application.Title := 'VistA Imaging MagKat';
  Application.CreateForm(TfrmMagKat, frmMagKat);
  Application.CreateForm(TfrmAbout, frmAbout);
  Application.CreateForm(TfrmPlatterReport, frmPlatterReport);
  Application.Run;
end.
