{*
 Classes and objects for the MagKat main form
}
unit fMagKatMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, cMagKatBroker, TLoggerUnit, TLevelUnit,
  TRollingFileAppenderUnit, TLayoutUnit, TPatternLayoutUnit, ExtCtrls, cMagKatUtils,
  StdCtrls, Buttons, cMagKatEngine, TFileAppenderUnit, inifiles, fMagAbout,
  magFileVersion, cMagKatJukeboxFileEngine, cMagKatPlatter, ImgList,
  fMagKatPlatterReport, fMagSelectDb;

type
  /// Contains the current processing state - possible states of the application
  TMagKatProcessingState = (MagKatNotProcessing, MagKatProcessingMagnetic, MagKatProcessingRange, MagKatProcessingJukebox);

  {*
    MagKat main form
  }
  TfrmMagKat = class(TForm)
    /// Page control to hold options for how to ues MagKat
    pgOptions: TPageControl;
    /// Main menu
    MainMenu1: TMainMenu;
    /// file menu
    mnuFile: TMenuItem;
    /// help menu
    mnuHelp: TMenuItem;
    /// help about menu
    mnuHelpAbout: TMenuItem;
    /// file login menu
    mnuFileLogin: TMenuItem;
    /// file logout menu
    mnuFileLogout: TMenuItem;
    /// menu seperator
    N2: TMenuItem;
    /// file exit menu
    mnuFileExit: TMenuItem;
    /// panel to display messages to the user
    pnlMessage: TPanel;
    /// tab sheet for magnetic options
    tsMagnetic: TTabSheet;
    /// tab sheet for ad hoc options
    tsRange: TTabSheet;
    /// edit box for the start IEN
    edtStartIEN: TLabeledEdit;
    /// edit box for the end IEN
    edtEndIEN: TLabeledEdit;
    /// button to process a range of files
    btnProcessRange: TBitBtn;
    /// button to stop processing a range of files
    btnProcessRangeStop: TBitBtn;
    /// the direction to process
    grpDirection: TGroupBox;
    /// process forwards
    rbForwards: TRadioButton;
    /// process backwards
    rbBackwards: TRadioButton;
    /// button to process sequentially
    btnProcessSequentially: TBitBtn;
    /// button to restart magnetic processing
    btnRestartProcessing: TBitBtn;
    /// button to stop processing sequentially
    btnStopSequentialProcessing: TBitBtn;
    /// combo to show locations to process
    cboProcessLocation: TComboBox;
    /// image storage location label
    lblImageStorageLocationLabel: TLabel;
    /// tab sheet for the jukebox
    tsJukebox: TTabSheet;
    /// tree view for the jukebox
    tvJukebox: TTreeView;
    /// group box for the platter status
    grpPlatterStatus: TGroupBox;
    /// process platter button
    btnProcessPlatter: TBitBtn;
    /// stop processing platter button
    btnStopProcessPlatter: TBitBtn;
    /// popup menu for jukebox platters
    jukeboxMenu: TPopupMenu;
    /// jukebox processing platter menu
    mnuJukeboxProcessPlatter: TMenuItem;
    /// throttle menu
    mnuThrottle: TMenuItem;
    /// throttle slow menu
    mnuThrottleSlow: TMenuItem;
    /// throttle speed up menu
    mnuThrottleSpeedUp: TMenuItem;
    /// process menu
    mnuProcess: TMenuItem;
    /// process magnetic menu
    mnuProcessMagnetic: TMenuItem;
    /// process range menu
    mnuProcessRange: TMenuItem;
    /// process jukebox menu
    mnuProcessJukebox: TMenuItem;
    /// process magnetic start menu
    mnuProcessMagneticStart: TMenuItem;
    /// process magnetic stop menu
    mnuProcessMagneticStop: TMenuItem;
    /// process magnetic seperator menu
    mnuProcessMagneticSeperator1: TMenuItem;
    /// process magnetic forwards menu
    mnuProcessMagneticForwards: TMenuItem;
    /// process magnetic backwards menu
    mnuProcessMagneticBackwards: TMenuItem;
    /// image list for image icons
    ImageList1: TImageList;
    /// process magnetic restart menu
    mnuProcessMagneticRestart: TMenuItem;
    /// process platter start menu
    mnuProcessPlatterStart: TMenuItem;
    /// process platter stop menu
    mnuProcessPlatterStop: TMenuItem;
    /// process range start menu
    mnuProcessRangeStart: TMenuItem;
    /// process range stop menu
    mnuProcessRangeStop: TMenuItem;
    /// platter name label
    lblPlatterNameLabel: TLabel;
    /// platter serial label
    lblPlatterSerialLabel: TLabel;
    /// platter name label
    lblPlatterName: TLabel;
    /// platter serial
    lblPlatterSerial: TLabel;
    /// progress bar for platter processing progress
    pbPlatterProgress: TProgressBar;
    /// panel for the bottom of MagKat
    pnlBottom: TPanel;
    /// group for processing status
    grpProcessStatus: TGroupBox;
    /// message label
    lblMessage: TLabel;
    /// last message label
    lblLastMessageLabel: TLabel;
    /// current processing rate label label
    lblCurrentProcessingRateLabel: TLabel;
    /// current processing rate label
    lblCurrentProcessingRate: TLabel;
    /// current txt file label
    lblCurrentTXTFile: TLabel;
    /// current text file label
    lblCurrentTxtFileLabel: TLabel;
    /// system impact throttle group box
    grpSystemImpaceThrottle: TGroupBox;
    /// fast label label
    lblFastLabel: TLabel;
    /// slow label label
    lblSlowLabel: TLabel;
    /// throttle track bar
    tbThrottle: TTrackBar;
    /// jukebox process platters menu
    mnuJukeboxProcessPlatters: TMenuItem;
    /// platter count label
    lblPlatterCount: TLabel;
    /// process sequential jukebox checkbox
    chkProcessSequentialJukebox: TCheckBox;
    /// hide jukebox panel
    pnlHideJukebox: TPanel;
    /// login requirred panel
    pnlLoginRequired: TPanel;
    /// platter failed files name label
    lblPlatterFailedFilesName: TLabel;
    /// platter failed files label
    lblPlatterFailedFiles: TLabel;
    /// jukebox image list
    imgJukebox: TImageList;
    /// jukebox view platter report menu
    mnuJukeboxViewPlatterReport: TMenuItem;
    /// process platter menu bar
    mnuProcessPlatterBar1: TMenuItem;
    /// process platter report menu
    mnuProcessPlatterReport: TMenuItem;
    /// recent error count label
    lblRecentErrorCount: TLabel;
    /// recent error count label label
    lblRecentErrorCountLabel: TLabel;
    /// hide ad hoc panel
    pnlHideAdHoc: TPanel;
    /// mark selected platter processed menu item
    mnuJukeboxMarkPlatterProcessed: TMenuItem;
    /// mark selected platter processed menu item
    mnuProcessPlatterMarkProcessed: TMenuItem;
    N1: TMenuItem;
    mnuFileConfigureServer: TMenuItem;
    mnuProcessAllowJukeboxSeperator1: TMenuItem;
    mnuProcessAllowJukeboxProcessingWithoutMagnetic: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure mnuFileLogoutClick(Sender: TObject);
    procedure mnuFileLoginClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnProcessRangeClick(Sender: TObject);
    procedure btnProcessRangeStopClick(Sender: TObject);
    procedure mnuFileExitClick(Sender: TObject);
    procedure tbThrottleChange(Sender: TObject);
    procedure btnProcessSequentiallyClick(Sender: TObject);
    procedure btnStopSequentialProcessingClick(Sender: TObject);
    procedure btnRestartProcessingClick(Sender: TObject);
    procedure mnuHelpAboutClick(Sender: TObject);
    procedure tvJukeboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure jukeboxMenuPopup(Sender: TObject);
    procedure btnStopProcessPlatterClick(Sender: TObject);
    procedure mnuThrottleSpeedUpClick(Sender: TObject);
    procedure mnuThrottleSlowClick(Sender: TObject);
    procedure mnuProcessMagneticForwardsClick(Sender: TObject);
    procedure mnuProcessMagneticBackwardsClick(Sender: TObject);
    procedure mnuProcessMagneticStartClick(Sender: TObject);
    procedure mnuProcessMagneticStopClick(Sender: TObject);
    procedure mnuProcessMagneticRestartClick(Sender: TObject);
    procedure rbBackwardsClick(Sender: TObject);
    procedure rbForwardsClick(Sender: TObject);
    procedure mnuProcessRangeStartClick(Sender: TObject);
    procedure mnuProcessRangeStopClick(Sender: TObject);
    procedure mnuProcessPlatterStartClick(Sender: TObject);
    procedure mnuProcessPlatterStopClick(Sender: TObject);
    procedure btnProcessPlatterClick(Sender: TObject);
    procedure mnuJukeboxProcessPlatterClick(Sender: TObject);
    procedure mnuJukeboxProcessPlattersClick(Sender: TObject);
    procedure mnuJukeboxViewPlatterReportClick(Sender: TObject);
    procedure mnuProcessPlatterReportClick(Sender: TObject);
    procedure tvJukeboxChange(Sender: TObject; Node: TTreeNode);
    procedure mnuJukeboxMarkPlatterProcessedClick(Sender: TObject);
    procedure mnuProcessPlatterMarkProcessedClick(Sender: TObject);
    procedure mnuFileConfigureServerClick(Sender: TObject);
    procedure mnuProcessAllowJukeboxProcessingWithoutMagneticClick(
      Sender: TObject);
    procedure pgOptionsChange(Sender: TObject);
  private
    /// Default information logger
    FLogger : TLogger;
    /// Broker connection to VistA database
    FMagKatBroker : TMagKatBroker;
    /// Engine for processing TXT files
    FMagKatEngine : TMagKatEngine;
    /// Engine for handling Jukebox platter information
    FMagKatJukeboxFileEngine : TMagKatJukeboxFileEngine;
    /// VistA Server connected to
    FServer : String;
    /// Vista Port connected to
    FPort : string;
    /// IEN of TXT file currently processing
    FCurrentIEN : String;
    /// Logger for keeping track of processed files
    FCompletedLogger : TLogger;
    /// Log file for error messages
    FErrorLogger : TLogger;
    /// Current processing state of application
    FCurrentProcessingState : TMagKatProcessingState;
    /// Filename of completed log file
    FCompletedLogFilename : String;
    /// INI component for MagKat
    FMagKatINI : TIniFile;
    /// Determines if the application is waiting to shut down
    FWaitingToShutdown : boolean;
    /// Determines if MagKat is ready to begin processing (initialization is complete)
    FMagKatReady : boolean;
    /// Determines if Magnetic processing has been completed
    FMagneticProcessingComplete : boolean;
    // nodes to hold the data in the jukebox platter tree
    /// Online node for online platters
    FOnlineNode : TTreeNode;
    /// Offline node for offline platters
    FOfflineNode : TTreeNode;
    /// Processed node for processed platters
    FProcessedNode : TTreeNode;
    /// the primary site station number for the site the user is logged into
    FPrimarySiteStationNumber : String;
    /// Tree node for offline error platters
    FOfflineErrorNode : TTreeNode;
    /// Tree node for online failed process platters
    FOnlineFailedProcessNode : TTreeNode;
    /// the directory to write log files to
    FLogsDir : string;
    /// The Defauult Vista server from the MagKat.ini file
    FDefaultLocalVista : String;
    /// The Defauult Vista server port from the MagKat.ini file
    FDefaultLocalVistaPort : String;

    procedure UpdateMainFormCaption();
    function validateRange(StartIEN : String; endIEN : String;
      var msg : String; var ProblemIndex : integer) : boolean;
    procedure UpdateMenuAndButtonOptions();
    procedure MagKatEngineProcessMessageEvent(Sender: TObject; msg : String);
    function Login(Server, Port : String) : boolean;
    procedure getImageCredentials();
    function InitializeMagKatStatus() : boolean;
    procedure MagKatEngineCurrentIENChangedEvent(Sender : TObject; IEN : String);
    procedure MagKatEngineFileProcessedEvent(Sender : TObject; IEN : String; FileLocation : TMagKatTXTFileLocation);
    procedure MagKatEngineProcessingStoppedEvent(Sender : TObject; LastIENProcessed : string);
    procedure MagKatEngineUpdateCurrentRateEvent(Sender : TObject; currentRate : String);
    procedure MagKatEngineProcessingCompletedEvent(Sender : TObject; LastIENProcessed : String; Msg : string);
    procedure MagKatEngineUpdateRecentErrorCountEvent(Sender : TObject; recentFailedCount : string);
    procedure CloseMagKat();
    procedure InitializeTreeView();
    procedure readCompletedFiles();
    procedure ProcessSelectedPlatter();
    function checkUserHasPermission(keys : TStringlist) : boolean;
    procedure MagKatEnginePlatterProcessingUpdateEvent(Sender : TObject;
      Platter : TMagKatPlatter; processed, failed, total : integer);
    procedure UpdatePlatterProcessingStatusDisplay(Platter : TMagKatPlatter;
      processed, failed, total : integer; UpdateSliderPosition : boolean);
    procedure ProcessPlatterGroup();
    procedure MagKatPlatterStatusUpdateUpdateEvent(Sender : TObject;
      Platter : TMagKatPlatter);
    procedure UpdatePlatter(Platter : TMagKatPlatter);
    procedure setPlatterIcon(Platter : TMagKatPlatter; PlatterNode : TTreeNode);
    function IsSelectedPlatterProcessed() : boolean;
    function SelectVistaDB() : boolean;
    function isNoJukeboxPlatters() : boolean;
  public
    { Public declarations }
  end;

const
  /// Required KEY to use MagKat
  MAG_KAT_REQUIRED_KEY = 'MAG DOD FIX';
  /// Filename for initial platters file from Dexter
  MAG_KAT_PLATTER_FILENAME = 'Platter Summary Report.txt';
  /// Filename to write update for platters list
  MAG_KAT_UPDATE_PLATTER_FILENAME = 'PlatterUpdateStatus.txt';

var
  /// Main form instance
  frmMagKat: TfrmMagKat;

implementation

{$R *.dfm}

{*
  FormCreate Event, initializes MagKat
  @param Sender Sender of the event
 }
procedure TfrmMagKat.FormCreate(Sender: TObject);
var
  JukeboxPlatterDirectory : String;
  
begin

  FLogsDir := cMagKatUtils.GetLogsDir();
  if not DirectoryExists(FLogsDir) then
  begin
    ForceDirectories(FLogsDir);
  end;
  FLogger := TLogger.GetInstance('MagKatInfo');
  FCompletedLogger := TLogger.GetInstance('MagKatImageComplete');
  FCompletedLogger.SetLevel(TLevelUnit.INFO);
  // create loggers and appenders (except file complete - done later)
  FLogger.Info('Starting MagKat');
  FErrorLogger := TLogger.GetInstance('MagKatError');
  FMagKatINI := TIniFile.Create(ChangeFileExt( Application.ExeName, '.INI'));
  tbThrottle.Position := FMagKatIni.ReadInteger('MagKatSettings', 'ThrottleValue', 0);
  JukeboxPlatterDirectory := FMagKatIni.ReadString('MagKatSettings','JukeboxPlatterDirectory',GetAppPath() + '\jukebox\');
  FMagneticProcessingComplete := FMagKatIni.ReadBool('MagKatStatus','MagneticComplete', false);
  chkProcessSequentialJukebox.Visible := FMagKatIni.ReadBool('MagKatSettings','MagneticJukebox', false);
  FDefaultLocalVista := FMagKatIni.ReadString('MagKatSettings','Local VistA','');
  FDefaultLocalVistaPort := FMagKatIni.ReadString('MagKatSettings','Local VistA port', '');

  FLogger.Info('Throttle position from INI file: ' + inttostr(tbThrottle.Position));
  
  getformposition(self, FMagKatINI);

  FWaitingToShutdown :=  false;
  FMagKatReady := false;      

  cboProcessLocation.Items.Add('All');
  cboProcessLocation.Items.Add('Magnetic');
  cboProcessLocation.Items.Add('Jukebox');

  cboProcessLocation.ItemIndex := 0;

  FMagKatJukeboxFileEngine := TMagKatJukeboxFileEngine.Create(FLogger,
    FErrorLogger, JukeboxPlatterDirectory);
  InitializeTreeView();

  pgOptions.Align := alClient;

  FCurrentProcessingState := MagKatNotProcessing;
  UpdateMenuAndButtonOptions();

  FMagKatBroker := TMagKatBroker.Create(FLogger, FErrorLogger);
  FMagKatEngine := TMagKatEngine.Create(FMagKatBroker, FLogger, FCompletedLogger,
    FErrorLogger, FMagKatJukeboxFileEngine);
  FMagKatEngine.OnMagKatEngineProcessMessage := MagKatEngineProcessMessageEvent;
  FMagKatEngine.OnMagKatEngineFileProcessed := MagKatEngineFileProcessedEvent;
  FMagKatEngine.OnMagKatEngineCurrentIENChanged := MagKatEngineCurrentIENChangedEvent;
  FMagKatEngine.OnMagKatEngineProcessingStopped := MagKatEngineProcessingStoppedEvent;
  FMagKatEngine.OnMagKatEngineUpdateCurrentRateEvent := MagKatEngineUpdateCurrentRateEvent;
  FMagKatEngine.OnMagKatEngineProcessingCompletedEvent := MagKatEngineProcessingCompletedEvent;
  FMagKatEngine.OnMagKatEnginePlatterProcessingUpdateEvent := MagKatEnginePlatterProcessingUpdateEvent;
  FMagKatEngine.OnMagKatPlatterStatusUpdateUpdateEvent := MagKatPlatterStatusUpdateUpdateEvent;
  FMagKatEngine.OnMagKatEngineUpdateRecentErrorCountEvent := MagKatEngineUpdateRecentErrorCountEvent;

  FMagKatEngine.ProcessingDelay := tbThrottle.Position;
  UpdateMainFormCaption();
//  pnlMessage.Caption := 'Select menu option "File | Log In" to connect to VistA';

  pgOptions.ActivePageIndex := 0;

  pnlHideJukebox.Align := alclient;
  pnlHideAdHoc.Align := alClient;
  pnlLoginRequired.Align := alClient;
  pnlLoginRequired.Caption := 'Please log in to VistA to use MagKat';
  pnlLoginRequired.Hint := 'Please log in to VistA to use MagKat';

  // check to be sure only one instance of MagKat is running
  if DoIExist('VistA Imaging MagKat') then
  begin
    // notify the user and terminate the 2nd instance of the applications
    self.hide();
    application.processmessages;
    showmessage('"VistA Imaging MagKat" is already running. ' + #13 + #13 +
      'A second instance will not be started.');
    Close();
    Application.Terminate();
    Application.ProcessMessages();
    exit;
  end
  else
  begin
    pnlMessage.Caption := 'Select menu option "File | Log In" to connect to VistA';
  end;
end;

{*
 Read the list of processed files and store for processing
 }
procedure TfrmMagKat.readCompletedFiles();
begin
  pnlMessage.Caption := 'Reading completed files';
  application.ProcessMessages;
  FMagKatJukeboxFileEngine.readCompletedFile(FCompletedLogFilename);
//  pnlMessage.Caption := 'Select menu option "File | Log In" to connect to VistA';
end;

{*
 Create and initialize the jukebox tree view
 }
procedure TfrmMagKat.InitializeTreeView();
var
  newNode : TTreeNode;
  platterNodeString : String;
  PlatterFile : String;
  UpdatePlatterFile : String;
  platterList : TList;
  platter : TMagKatPlatter;
  i : integer;
begin
  fonlineNode := tvJukebox.Items.AddChild(nil, 'Online Unprocessed');
  FOnlineNode.ImageIndex := 0;
  FOnlineNode.SelectedIndex := 0;
  FOnlineFailedProcessNode := tvJukebox.Items.AddChild(nil, 'Online Scanned, Needs Review');
  FOnlineFailedProcessNode.ImageIndex := 5;
  FOnlineFailedProcessNode.SelectedIndex := 5;
  fprocessedNode := tvJukebox.Items.AddChild(nil, 'Processed');
  FProcessedNode.ImageIndex := 2;
  FProcessedNode.SelectedIndex := 2;
  fofflineNode := tvJukebox.Items.AddChild(nil, 'Offline Unprocessed');
  FOfflineNode.ImageIndex := 1;
  FOfflineNode.SelectedIndex := 1;
  FOfflineErrorNode := tvJukebox.Items.AddChild(nil, 'Offline Error');
  FOfflineErrorNode.ImageIndex := 6;
  FOfflineErrorNode.SelectedIndex := 6;

  PlatterFile := FMagKatJukeboxFileEngine.PlatterDirectory +
    MAG_KAT_PLATTER_FILENAME;
  UpdatePlatterFile := FMagKatJukeboxFileEngine.PlatterDirectory +
    MAG_KAT_UPDATE_PLATTER_FILENAME;
  if FileExists(PlatterFile) then
  begin
    FLogger.Info('Reading platters from [' + PlatterFile + ']');
    pnlMessage.Caption := 'Reading platter information';
    platterList := FMagKatJukeboxFileEngine.readPlatterFromFile(PlatterFile,
      UpdatePlatterFile);
    FLogger.info('Found [' + inttostr(platterlist.Count) + '] platters');
    for i := 0 to platterList.Count - 1 do
    begin
      platter := platterList.Items[i];
      platterNodeString := platter.PlatterDisplayName;
      FLogger.Info('Adding platter [' + platterNodeString + '] with status [' + platter.PlatterStatusString + ']');
      if platter.PlatterStatus = Online then
      begin
        newNode := tvJukebox.Items.AddChild(fonlineNode, platternodestring);
      end
      else if platter.PlatterStatus = Offline then
      begin
        newNode := tvJukebox.Items.AddChild(fofflineNode, platternodestring);
      end
      else if platter.PlatterStatus = Processed then
      begin
        newNode := tvJukebox.Items.AddChild(fprocessedNode, platternodestring);
      end
      else if platter.PlatterStatus = OfflineError then
      begin
        newNode := tvJukebox.Items.AddChild(FOfflineErrorNode, platterNodeString);
      end
      else if platter.PlatterStatus = OnlineFailedProcess then
      begin
        newNode := tvJukebox.Items.AddChildFirst(FOnlineFailedProcessNode, platterNodeString)
      end;
      newNode.Data := platter;
      setPlatterIcon(platter, newNode);
    end;
    FreeAndNil(platterList);
  end
  else
  begin
    FLogger.Warn('Platter file [' + PlatterFile + '] does not exist');
    pnlMessage.Caption := 'Cannot read platters, platter file does not exist';
  end;
  fonlineNode.Expanded := true;
  fofflineNode.Expanded := true;
  fprocessedNode.Expanded := true;
  FOfflineErrorNode.Expanded := true;
  FOnlineFailedProcessNode.Expanded := true;
  tvJukebox.Selected := tvJukebox.Items.GetFirstNode;
end;

{*
 File logout event, closes the VistA connection
 @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuFileLogoutClick(Sender: TObject);
begin
  if FMagKatBroker <> nil then
  begin
    FMagKatBroker.Logout;
  end;
  if FMagKatEngine <> nil then
  begin
    FMagKatEngine.ClearImageShareCredentials(); 
  end;
  if FMagKatJukeboxFileEngine <> nil then
  begin
    FMagKatJukeboxFileEngine.clearCompletedFile();
  end;
  pnlMessage.Caption := 'No connection to VistA';
  UpdateMainFormCaption();
  UpdateMenuAndButtonOptions();
end;

{*
 File Login event, logs into VistA
 @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuFileLoginClick(Sender: TObject);
begin
  if (FDefaultLocalVista = '') or (FDefaultLocalVistaPort = '') then
  begin
    if SelectVistaDB() then
      login(FDefaultLocalVista, FDefaultLocalVistaPort);
  end
  else
  begin
    login(FDefaultLocalVista, FDefaultLocalVistaPort);
  end;
end;

{*
 Logs into the VistA database with the specified server and port
 @param Server The VistA server to connect to
 @param Port The VistA port to connect to
 @return True if the connection was made, false otherwise
 }
function TfrmMagKat.Login(Server, Port : String) : boolean;
var
  userKeys : TStringlist;
  loginResult : TMagKatBrokerLoginResult;
  msg : string;
  fileAppender : TFileAppender;
begin
  try
    Cursor := crHourGlass;
    FMagKatReady := false;
    pnlMessage.Caption := 'Logging into VistA...';
    loginResult := FMagKatBroker.login(server, port, msg);
    if loginResult = MagKatLoginOK then
    begin
      Fserver := server;
      Fport := port;

      userKeys := TStringList.Create();
      if not FMagKatBroker.getUserKeys(userKeys) then
      begin
        FMagKatBroker.Logout();
        MessageDlg('Error retrieving user keys',
          mtInformation, TOKButtonOnly, -1);
        FMagKatReady := false;
        pnlMessage.Caption := 'Insufficient permission to run MagKat';
        exit;
      end;
      if not checkUserHasPermission(userKeys) then
      begin
        FMagKatBroker.Logout();
        MessageDlg('You do not have adequate permission to run this application.'
          + #13 + 'You must have the key [' + MAG_KAT_REQUIRED_KEY + ']',
          mtInformation, TOKButtonOnly, -1);
        FMagKatReady := false;
        pnlMessage.Caption := 'Insufficient permission to run MagKat';
        exit;
      end;
      getImageCredentials();
      FCompletedLogFilename :=  FLogsDir + '\' + FPrimarySiteStationNumber +
        '_MagKatImageComplete.log';
      if not FileExists(FCompletedLogFilename) then
      begin
        cMagKatUtils.CreateEmptyFile(FCompletedLogFilename);
      end;

      pnlLoginRequired.Caption := 'Please wait while loading list of completed files';
      pnlLoginRequired.Hint := 'Please wait while loading list of completed files';

      Cursor := crHourGlass;

      // if there was a previous login then there would already be an appender - remove
      // it so we can set a new one which might be a new file
      FCompletedLogger.RemoveAllAppenders();

      readCompletedFiles();

      fileAppender := TFileAppender.Create(FCompletedLogFilename, TPatternLayout.Create('[%d] %m%n'), true);
      FCompletedLogger.AddAppender(fileAppender);
      Cursor := crDefault;
      pnlMessage.Caption := 'Connected to VistA';

      if InitializeMagKatStatus() then
      begin
        FMagKatReady := true;
      end
      else
      begin
        pnlMessage.Caption := 'Insufficient permission to run MagKat';
        // do something to disable processing...
      end;
    end
    else if loginResult = MagKatLoginContextFailed then
    begin
      pnlMessage.Caption := 'No connection to VistA';
      MessageDlg('Unable to log in to database, you must have the ' +
        FMagKatBroker.getRequiredContext() + ' context to use MagKat' + #13 +
        'Connection to VistA Closed',
        mtError, TOKButtonOnly, -1);
    end
    else if loginResult = MagKatLoginCancelled then
    begin
      pnlMessage.Caption := 'VistA connection cancelled';
    end
    else
    begin
      pnlMessage.Caption := 'No connection to VistA';
      MessageDlg('Error connecting to VistA' + #13 + msg,
        mtError, TOKButtonOnly, -1);
    end;
    UpdateMainFormCaption();
    UpdateMenuAndButtonOptions();
  finally
    Cursor := crDefault;
  end;
end;

{*
 Updates the caption of the main form to reflect the current connection
 status to include the server and user name
 }
procedure TfrmMagKat.UpdateMainFormCaption();
begin
  if FMagKatBroker = nil then
  begin
    self.Caption := 'VistA Imaging MagKat';
  end
  else
  begin
    if FMagKatBroker.Connected then
    begin
      self.Caption := 'VistA Imaging MagKat : (' + FServer + ') in use by : ' +
      FMagKatBroker.UserFullName;
    end
    else
    begin
      self.Caption := 'VistA Imaging MagKat';
    end;
  end;
end;

{*
 Closes the MagKat form and the application
 @param Sender the object which called this event
 @param Action The action to take
 }
procedure TfrmMagKat.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FCurrentProcessingState <> MagKatNotProcessing then
  begin
    if FMagKatEngine <> nil then
    begin
      FWaitingToShutdown := true;
      action := caNone;
      FMagKatEngine.stopProcessing();
      exit;
    end;
  end;
  CloseMagKat();
end;

{*
 Closes connections and writes entries to the INI file and then closes MagKat
 }
procedure TfrmMagKat.CloseMagKat();
var
  platterList : TList;
  i : integer;
  platter : TMagKatPlatter;
begin
  platterList := nil;
  try
    try
      FMagKatIni.WriteInteger('MagKatSettings','ThrottleValue',tbThrottle.Position);
      // if its not complete, then delete the key
      if not FMagneticProcessingComplete then
        FMagKatINI.DeleteKey('MagKatStatus','MagneticComplete')
      else
        FMagKatIni.WriteBool('MagKatStatus','MagneticComplete', FMagneticProcessingComplete);
      if FMagKatJukeboxFileEngine.PlattersUpdated then
      begin
        platterList := TList.Create();
        for i := 0 to tvJukebox.Items.Count - 1 do
        begin
          if tvJukebox.Items[i].Data <> nil then
          begin
            platter := tvJukebox.Items[i].Data;
            platterList.Add(platter);
          end;
        end;
        FMagKatJukeboxFileEngine.writePlatterstoFile(
          FMagKatJukeboxFileEngine.PlatterDirectory +
          MAG_KAT_UPDATE_PLATTER_FILENAME, platterList);
      end;
      for i := 0 to tvJukebox.Items.Count - 1 do
      begin
        if tvJukebox.Items[i].Data <> nil then
        begin
          platter := tvJukebox.Items[i].Data;
          FreeAndNil(platter);
        end;
      end;
      tvJukebox.Items.Clear();
      if FMagKatJukeboxFileEngine <> nil then
      begin
        // want to write a new version of the file with better sorting
        // and organization (will make loading the file more accurate)
        FCompletedLogger.RemoveAllAppenders();
        FMagKatJukeboxFileEngine.writeProcessedToFile(FCompletedLogFilename);
        FMagKatJukeboxFileEngine.clearCompletedFile();
      end;
      saveformposition(self, FMagKatINI);
    finally
      FMagKatINI.Free;
      FMagKatIni := nil;
      if platterList <> nil then
        FreeAndNil(platterList);
    end;

    if FMagKatBroker <> nil then
    begin
      FMagKatBroker.Logout;
      FreeAndNil(FMagKatBroker);
    end;
    if FMagKatEngine <> nil then
    begin
      FMagKatEngine.stopProcessing();
      FreeAndNil(FMagKatEngine);
    end;
    if FMagKatJukeboxFileEngine <> nil then
    begin
      FreeandNil(FMagKatJukeboxFileEngine);
    end;
  except
    on E : Exception do
    begin
      FLogger.Error('Error closing MagKat [' + e.Message + ']');
      FErrorLogger.Error('Error closing MagKat [' + e.Message + ']');
      MessageDlg('Error closing MagKat: ' + e.Message,
        mtInformation, TOKButtonOnly, -1);
    end;
  end;
  FLogger.Info('Closing MagKat');
  TLogger.FreeInstances;
  application.Terminate;
end;

{*
 Validates the start ien is before the end IEN and they aer both numbers
 @param StartIEN the start of the range
 @param endIEN the end of the range
 @param msg Result message if there is an error
 @param ProblemIndex indicates if problem is with start or end IEN value - 1 for start, 2 for end
 @return True if the input is valid, false otherwise
 }
function TfrmMagKat.validateRange(StartIEN : String; endIEN : String;
  var msg : String; var ProblemIndex : integer) : boolean;
var
  first, last : integer;
begin
  result := true;
  msg := '';
  ProblemIndex := 0;
  try
    first := strtoint(StartIEN);
   except
    on E : Exception do
    begin
      FLogger.Error(e.Message);
      msg := 'Start IEN must be integer value';
      result := false;
      ProblemIndex := 1;
      exit;
    end;
  end;

  try
    last := strtoint(endien);
  except
    on E : Exception do
    begin
      FLogger.Error(e.Message);
      result := false;
      msg := 'End IEN must be integer value';
      ProblemIndex := 2;
      exit;
    end;
  end;
  if first < 0 then
  begin
    result := false;
    msg := 'Start IEN must be greater than 0';
    ProblemIndex := 1;
  end
  else if first <= last then
    result := true
  else
  begin
    result := false;
    msg := 'Start IEN must be before end IEN';
    ProblemIndex := 1;
  end;                
end;

{*
  Process range button click event
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.btnProcessRangeClick(Sender: TObject);
var
  st, ed : integer;
  FileLocation : TMagKatTXTFileLocation;
  errMsg : String;
  ProblemIndex : integer;
begin
  if not validateRange(edtStartIEN.Text, edtEndIEN.Text, errMsg, ProblemIndex) then
  begin
    MessageDlg('Invalid range specified, ' + errMsg,
      mtWarning, TOKButtonOnly, -1);
    if ProblemIndex = 1 then
      edtStartIEN.SetFocus()
    else if ProblemIndex = 2 then
      edtEndIEN.SetFocus();
    exit;
  end;
  Cursor := crHourGlass;
  FCurrentProcessingState := MagKatProcessingRange;
  btnProcessRange.Enabled := false;
  btnProcessRangeStop.Enabled := true;
  st := strtoint(edtStartIEN.Text);
  ed := strtoint(edtEndIEN.Text);

  if cboProcessLocation.ItemHeight = 1 then
    FileLocation := MagKatMagnetic
  else if cboProcessLocation.ItemIndex = 2 then
    FileLocation := MagKatJukebox
  else
    FileLocation := MagKatAll;

  UpdateMenuAndButtonOptions();
  FMagKatEngine.ProcessRange(st, ed, FileLocation);

  Cursor := crDefault;
  pnlMessage.Caption := 'Processing of range [' + edtStartIEN.Text + ' - ' + edtEndIEN.Text + '] complete';
end;

{*
  Update the enabled menu and button options based on the current state of
  the application
 }
procedure TfrmMagKat.UpdateMenuAndButtonOptions();
begin
  if FMagKatBroker = nil then
  begin
    mnuFileLogin.Enabled := true;
//    mnuFileRemoteLogin.Enabled := true;
    mnuFileLogout.Enabled := false;

    btnProcessRange.Enabled := false;
    btnProcessRangeStop.Enabled := false;

    pgOptions.Enabled := false;
    mnuProcess.Enabled := false;
    pnlLoginRequired.Visible := true;
  end
  else
  begin
    pgOptions.Enabled := (FMagKatBroker.Connected) and (FMagKatReady);
    pnlLoginRequired.Visible := not pgOptions.Enabled;
    if FMagKatBroker.Connected then
    begin
      mnuFileLogin.Enabled := false;
//      mnuFileRemoteLogin.Enabled := false;
      mnuFileLogout.Enabled := true;
    end
    else
    begin
      mnuFileLogin.Enabled := true;
//      mnuFileRemoteLogin.Enabled := true;
      mnuFileLogout.Enabled := false;
    end;
    if pgOptions.Enabled then
    begin
      mnuProcess.Enabled := true;
      mnuProcessPlatterReport.Enabled := false;
      mnuProcessPlatterMarkProcessed.Enabled := false;
      pnlHideJukebox.Visible := not FMagneticProcessingComplete;
      pnlHideAdHoc.Visible := not FMagneticProcessingComplete;
      mnuProcessAllowJukeboxProcessingWithoutMagnetic.Visible := not FMagneticProcessingComplete;
      mnuProcessAllowJukeboxSeperator1.Visible := not FMagneticProcessingComplete;
      if FCurrentProcessingState = MagKatNotProcessing then
      begin
        // magnetic
        mnuProcessMagnetic.Enabled := true;
        mnuProcessMagneticStop.Enabled := false;
        mnuProcessMagneticStart.Enabled := true;
        mnuProcessMagneticRestart.Enabled := true;
        mnuProcessMagneticForwards.Enabled := true;
        mnuProcessMagneticBackwards.Enabled := true;
        grpDirection.Enabled := true;
        btnProcessSequentially.Enabled := true;
        btnStopSequentialProcessing.Enabled := false;
        btnRestartProcessing.Enabled := true;
        // range
        mnuProcessRange.Enabled := FMagneticProcessingComplete;
        mnuProcessRangeStart.Enabled := FMagneticProcessingComplete;
        mnuProcessRangeStop.Enabled := false;
        btnProcessRange.Enabled := FMagneticProcessingComplete;
        btnProcessRangeStop.Enabled := false;
        // jukebox
        btnStopProcessPlatter.Enabled := false;
        mnuProcessPlatterStop.Enabled := false;
          // jukebox is only allowed after magnetic processing has been completed
        mnuProcessJukebox.Enabled := FMagneticProcessingComplete;
        mnuProcessPlatterStart.Enabled := FMagneticProcessingComplete;
        btnProcessPlatter.Enabled := FMagneticProcessingComplete;
        mnuJukeboxProcessPlatter.Enabled := FMagneticProcessingComplete;
        mnuJukeboxProcessPlatters.Enabled := FMagneticProcessingComplete;
        if tvJukebox.Selected <> nil then
        begin
          if tvJukebox.Selected.Data <> nil then
          begin
            mnuProcessPlatterReport.Enabled := true;
            if IsSelectedPlatterProcessed() then
              mnuProcessPlatterMarkProcessed.Enabled := false
            else
              mnuProcessPlatterMarkProcessed.Enabled := true;
          end;
        end;
      end
      else if FCurrentProcessingState = MagKatProcessingMagnetic then
      begin
        btnProcessRange.Enabled := false;
        btnProcessRangeStop.Enabled := false;
        btnProcessSequentially.Enabled := false;
        btnRestartProcessing.Enabled := false;
        btnStopSequentialProcessing.Enabled := true;
        btnProcessPlatter.Enabled := false;
        btnStopProcessPlatter.Enabled := false;
        mnuProcessMagnetic.Enabled := true;
        mnuProcessRange.Enabled := false;
        mnuProcessJukebox.Enabled := false;
        // set magnetic menu options
        mnuProcessMagneticStart.Enabled := false;
        mnuProcessMagneticRestart.Enabled := false;
        mnuProcessMagneticForwards.Enabled := false;
        mnuProcessMagneticBackwards.Enabled := false;
        mnuProcessMagneticStop.Enabled := true;
        grpDirection.Enabled := false;
        mnuJukeboxProcessPlatter.Enabled := false;
        mnuJukeboxProcessPlatters.Enabled := false;
        mnuProcessPlatterStart.Enabled := false;
        mnuProcessPlatterStop.Enabled := false;
      end
      else if FCurrentProcessingState = MagKatProcessingRange then
      begin
        btnProcessRange.Enabled := false;
        btnProcessRangeStop.Enabled := true;
        btnProcessSequentially.Enabled := false;
        btnRestartProcessing.Enabled := false;
        btnStopSequentialProcessing.Enabled := false;
        btnProcessPlatter.Enabled := false;
        btnStopProcessPlatter.Enabled := false;
        mnuProcessMagnetic.Enabled := false;
        mnuProcessRange.Enabled := true;
        mnuProcessJukebox.Enabled := false;
        grpDirection.Enabled := false;
        mnuProcessRangeStart.Enabled := false;
        mnuProcessRangeStop.Enabled := true;
        mnuJukeboxProcessPlatter.Enabled := false;
        mnuJukeboxProcessPlatters.Enabled := false;
        mnuProcessPlatterStart.Enabled := false;
        mnuProcessPlatterStop.Enabled := false;
      end
      else if FCurrentProcessingState = MagKatProcessingJukebox then
      begin
        btnProcessRange.Enabled := false;
        btnProcessRangeStop.Enabled := false;
        btnProcessSequentially.Enabled := false;
        btnRestartProcessing.Enabled := false;
        btnStopSequentialProcessing.Enabled := false;
        btnProcessPlatter.Enabled := false;
        btnStopProcessPlatter.Enabled := true;
        mnuProcessMagnetic.Enabled := false;
        mnuProcessRange.Enabled := false;
        mnuProcessJukebox.Enabled := true;
        mnuProcessPlatterStart.Enabled := false;
        mnuProcessPlatterStop.Enabled := true;
        grpDirection.Enabled := false;
        mnuJukeboxProcessPlatter.Enabled := false;
        mnuJukeboxProcessPlatters.Enabled := false;
      end;
    end;
  end;
end;

{*
  Event when the MagKat engine has a processing message event
  @param Sender The object which sent the event
  @param Msg The message to display
 }
procedure TfrmMagKat.MagKatEngineProcessMessageEvent(Sender: TObject; msg : String);
begin
  lblMessage.Caption := Msg;
  application.ProcessMessages();
end;

{*
  Button event for when the process range stop button is pressed
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.btnProcessRangeStopClick(Sender: TObject);
var
  lastIen : string;
begin
  if FMagKatEngine <> nil then
  begin
    lastIen := FMagKatEngine.stopProcessing();
    application.ProcessMessages();
    if lastIen <> '' then
      edtStartIEN.Text := lastIen;
  end;
end;

{*
  Event for the File Exit menu option
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuFileExitClick(Sender: TObject);
begin
  if FCurrentProcessingState <> MagKatNotProcessing then
  begin
    if FMagKatEngine <> nil then
    begin
      FWaitingToShutdown := true;
      FMagKatEngine.stopProcessing();
      exit;
    end;
  end;
  CloseMagKat();
end;

{*
  Event for when the throttle value has changed
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.tbThrottleChange(Sender: TObject);
begin
//  lblThrottle.Caption := inttostr(tbThrottle.Position);
  if(FMagKatEngine <> nil) then
    FMagKatEngine.ProcessingDelay := tbThrottle.Position;
end;

{*
  Get the credentials to access the image network shares from the broker
 }
procedure TfrmMagKat.getImageCredentials();
var
  user, pass : string;
  shares : TStrings;
begin
  if (FMagKatBroker = nil) or (FMagKatEngine = nil) then
    exit;
  FMagKatBroker.getSiteParameterCredentials(user, pass, FPrimarySiteStationNumber);
  shares := TStringList.Create();
  if FMagKatBroker.getNetworkLocations(shares) then
  begin
    FMagKatEngine.SetImageShareCredentials(user, pass, shares);
  end;
end;

{*
  Initialze the status of MagKat based on the status stored in the database
  @return True if the initialization completed successfully, false if there
  was an error.
 }
function TfrmMagKat.InitializeMagKatStatus() : boolean;
var
  output : string;
  dir  : string;
  l : integer;
begin
  result := FMagKatBroker.initMagScanImageTextFiles(output);

  l := pos('-13', output) ;
  if l = 1 then
    result := false;

  if result then
  begin
    FLogger.Info('Result from init [' + output + ']');

    FCurrentIEN := MagPiece(output, '^', 1);
    dir := MagPiece(output, '^', 2);
    if dir = '1' then
    begin
      rbForwards.Checked := true;
      mnuProcessMagneticForwards.Checked := true;
    end
    else
    begin
      rbBackwards.Checked := true;
      mnuProcessMagneticBackwards.Checked := true;
    end;
    lblCurrentTXTFile.Caption := FCurrentIEN;
  end
  else
  begin
    showmessage('Error during initMagScanImageTextFiles: ' + MagPiece(output, ',', 2));
  end;
end;

{*
  Event occurs when the MagKat engine changes the IEN it is currently processing
  @param Sender The object which sent the event
  @param IEN The IEN currently processing
 }
procedure TfrmMagKat.MagKatEngineCurrentIENChangedEvent(Sender : TObject; IEN : String);
begin
  FCurrentIEN := IEN;
  lblCurrentTXTFile.Caption := FCurrentIEN;
end;

{*
  Event occurs when the MagKat engine reports a file has been processed
  @param Sender The object which sent the event
  @param IEN The ien of the file
  @param FileLocation The location of the file
 }
procedure TfrmMagKat.MagKatEngineFileProcessedEvent(Sender : TObject;
  IEN : String; FileLocation : TMagKatTXTFileLocation);
begin
  // The completed logging is done by the MagKat Engine
end;

{*
  Button event occurs when the process sequentially button is pressed
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.btnProcessSequentiallyClick(Sender: TObject);
var
  direction : TMagKatProcessDirection;
  fileLocation : TMagKatTXTFileLocation;
begin
  Cursor := crHourGlass;
  FCurrentProcessingState := MagKatProcessingMagnetic;
  if rbForwards.Checked then
    direction := MagKatProcessForwards
  else
    direction := MagKatProcessBackwards;
  UpdateMenuAndButtonOptions();
  pnlMessage.Caption := 'Processing Magnetic';

  if (chkProcessSequentialJukebox.Visible) and
    (chkProcessSequentialJukebox.Checked) then
  begin
    fileLocation := MagKatAll;
    FLogger.Info('Processing magnetic with jukebox');
  end
  else
    fileLocation := magKatMagnetic;

  FMagKatEngine.ProcessSequentially(FCurrentIEN, direction, fileLocation);
end;

{*
  Button event occurs when the stop sequential processing button is pressed
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.btnStopSequentialProcessingClick(Sender: TObject);
var
  lastIen : string;
begin
  if FMagKatEngine <> nil then
  begin
    lastIen := FMagKatEngine.stopProcessing();
    application.ProcessMessages();
  end;
end;

{*
  Button event for when the restart processing button is pressed
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.btnRestartProcessingClick(Sender: TObject);
var
  output : string;
  dialogResult : integer;
begin
  dialogResult := MessageDlg('Are you sure you want to restart the scanning ' +
    'process from the begining (this will re-process all of your images)?',
    mtConfirmation, mbYesNoCancel, -1);
  if dialogResult = mrYes then
  begin
    if FMagKatBroker.restartMagScanImageTextFiles(output) then
    begin
      FLogger.Info('Response from restart of Scan [' + output + ']');
      FCurrentIEN := '';
      lblCurrentTXTFile.Caption := '';
      pnlMessage.Caption := 'Processing has been restarted';
      btnProcessSequentiallyClick(self); // automatically start processing again
    end
    else
    begin
      FLogger.Error('Error restarting scan [' + output + ']');
      FErrorLogger.Error('Error restarting scan [' + output + ']');
      pnlMessage.Caption := 'Error restarting scan [' + output + ']';
    end;
  end;
end;

{*
  Event occurs when the MagKat Engine has stopped processing (does not incidate
  processing was completed).
  @param Sender The object which sent the event
  @param LastIENProcessed The ien of the last image the MagKat engine procesed
 }
procedure TfrmMagKat.MagKatEngineProcessingStoppedEvent(Sender : TObject; LastIENProcessed : string);
begin

  if FWaitingToShutdown then
  begin
    FCurrentProcessingState := MagKatNotProcessing;
    CloseMagKat();
  end
  else
  begin
    if LastIENProcessed <> '' then
      pnlMessage.Caption := 'Stopped processing after processing TXT file [' + LastIENProcessed + ']'
    else
      pnlMessage.Caption := 'Processing stopped';
    MessageDlg(FMagKatEngine.getCurrentProcessingProgressDetails(),
      mtInformation, TOKButtonOnly, -1);
    FCurrentProcessingState := MagKatNotProcessing;
    UpdateMenuAndButtonOptions();
    cursor := crDefault;
  end;
end;

{*
  Event occurs when the MagKat Engine updates the current rate of processing
  @param Sender The object which sent the event
  @param CurrentRate The current rate of processing
 }
procedure TfrmMagKat.MagKatEngineUpdateCurrentRateEvent(Sender : TObject;
  currentRate : String);
begin
  lblCurrentProcessingRate.Caption := currentRate;
end;

{*
  Event occurs when the MagKat engine updates the recent error count
  @param Sender The object which sent the event
  @param RecentFailedCount The recent number of txt files that failed to process
 }
procedure TfrmMagKat.MagKatEngineUpdateRecentErrorCountEvent(Sender : TObject;
  recentFailedCount : string);
begin
  lblRecentErrorCount.Caption := recentFailedCount;
end;

{*
  Event occurs when the MagKat engine has completed processing
  @param Sender The object which sent the event
  @param LastIENProcessed The ien of the last txt file that was processed
 }
procedure TfrmMagKat.MagKatEngineProcessingCompletedEvent(Sender : TObject;
  LastIENProcessed : String; Msg : string);
begin
  if FCurrentProcessingState = MagKatProcessingMagnetic then
  begin
    FMagneticProcessingComplete := true;
  end
  else if FCurrentProcessingState = MagKatProcessingJukebox then
  begin
    pbPlatterProgress.Position := 0;
  end;
  cursor := crDefault;
  MessageDlg(FMagKatEngine.getCurrentProcessingProgressDetails(),
    mtInformation, TOKButtonOnly, -1);
  FCurrentProcessingState := MagKatNotProcessing;
  pnlMessage.Caption := msg;
  UpdateMenuAndButtonOptions();
end;

{*
  Menu event when help about is selected
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuHelpAboutClick(Sender: TObject);
var
  rstat : boolean;
  rlist : Tstringlist;
  magver,vstat : string;//59
begin
  rlist := Tstringlist.create;
  try
    FMagKatBroker.RPMaggInstall(rstat,rlist);
    // pre 59 frmAbout.execute('','',rlist);
    {p59 Display Version Status : Alpha/Beta or Released}
    magver := MagGetFileVersionInfo(application.exename);	//59
    FMagKatBroker.RPMagVersionStatus(vstat, magver);	//59
    frmAbout.execute('','',rlist,magpiece(vstat,'^',2));	//59
  finally
    rlist.free;
  end;
end;

{*
  Event occurs when the mouse is pressed down on the jukebox tree view
  @param Sender The object which sent the event
  @param button the button on the mouse that was clicked
  @param Shift If the shift button was selected
  @param X The X coordinate of the mouse
  @param Y The Y coordinate of the mouse
 }
procedure TfrmMagKat.tvJukeboxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  tNode : TTreeNode;
begin
  // maybe this should only happen for right mouse button?
  tNode := tvJukebox.GetNodeAt(x, y);
  tvJukebox.Selected := tNode;
end;

{*
  Event occurs when the jukebox popup menu appears
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.jukeboxMenuPopup(Sender: TObject);
begin
  if tvJukebox.Selected = nil then
  begin
    mnuJukeboxProcessPlatter.Enabled := false;
    mnuJukeboxProcessPlatter.Visible := true;
    mnuJukeboxProcessPlatters.Visible := false;
    mnuJukeboxViewPlatterReport.Visible := false;
    mnuJukeboxMarkPlatterProcessed.Visible := false;
  end
  else
  begin
    if tvJukebox.Selected.Data = nil then
    begin
      mnuJukeboxProcessPlatter.Visible := false;
      mnuJukeboxProcessPlatters.Visible := true;
      mnuJukeboxViewPlatterReport.Visible := false;
      mnuJukeboxMarkPlatterProcessed.Visible := false;
    end
    else
    begin
      mnuJukeboxProcessPlatter.Visible := true;
      mnuJukeboxProcessPlatters.Visible := false;
      mnuJukeboxViewPlatterReport.Visible := true;
      mnuJukeboxMarkPlatterProcessed.Visible := true;
      if IsSelectedPlatterProcessed() then
        mnuJukeboxMarkPlatterProcessed.Enabled := false
      else
        mnuJukeboxMarkPlatterProcessed.Enabled := true;
    end;
  end;
end;

{*
  Process the selected platter
 }
procedure TfrmMagKat.ProcessSelectedPlatter();
var
  platter : TMagKatPlatter;
  dlgResult : integer;
begin
  if tvJukebox.Selected = nil then exit;

  if tvJukebox.Selected.Data = nil then
  begin
    MessageDlg('You must select a platter to process.', mtInformation, TOKButtonOnly, -1);
    exit;
  end;
  platter := tvJukebox.Selected.Data;
  if platter.PlatterStatus = Offline then
  begin
    dlgResult := MessageDlg('Platter status was offline, if this platter has ' +
      'not been brought back online and VistA updated with the new platter ' +
      'status, then processing will not work. Continue processing this platter?',
      mtConfirmation, mbYesNoCancel, -1);
    if (dlgResult = mrNo) or (dlgResult = mrCancel) then
      exit;
  end;

  Cursor := crHourGlass;
  FCurrentProcessingState := MagKatProcessingJukebox;
  UpdateMenuAndButtonOptions();
  FMagKatEngine.ProcessPlatter(platter);
end;

{*
  Button event for when the stop process platter button is pressed
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.btnStopProcessPlatterClick(Sender: TObject);
var
  lastIen : string;
begin
  if FMagKatEngine <> nil then
  begin
    lastIen := FMagKatEngine.stopProcessing();
    application.ProcessMessages();
  end;
end;

{*
  Menu event for when throttle speed up is selected 
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuThrottleSpeedUpClick(Sender: TObject);
begin
  tbThrottle.Position := tbThrottle.Position - 10;
end;

{*
  Menu event for throttle slow down
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuThrottleSlowClick(Sender: TObject);
begin
  tbThrottle.Position := tbThrottle.Position + 10;
end;

{*
  Menu event for process magnetic forwards
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessMagneticForwardsClick(Sender: TObject);
begin
  mnuProcessMagneticForwards.Checked := true;
  rbForwards.Checked := true;
end;

{*
  Menu event for process magnetic backwards
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessMagneticBackwardsClick(Sender: TObject);
begin
  mnuProcessMagneticBackwards.Checked := true;
  rbBackwards.Checked := true;
end;

{*
  Menu event for process magnetic start
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessMagneticStartClick(Sender: TObject);
begin
  pgOptions.ActivePageIndex := 0;
  btnProcessSequentiallyClick(self);
end;

{*
  Menu event for process magnetic stop
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessMagneticStopClick(Sender: TObject);
begin
  pgOptions.ActivePageIndex := 0;
  btnStopSequentialProcessingClick(self);
end;

{*
  Menu event for proces magnetic restart
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessMagneticRestartClick(Sender: TObject);
begin
  pgOptions.ActivePageIndex := 0;
  btnRestartProcessingClick(self);
end;

{*
  Checks to see if the user has the requirred keys to run MagKat
  @param Keys the keys the user has
  @return True if the user has permission to use MagKat, false if they do not.
 }
function TfrmMagKat.checkUserHasPermission(keys : TStringlist) : boolean;
begin
  if keys = nil then
  begin
    result := false;
    FLogger.Error('Security keys are not initialized, no keys provided');
  end;
  result := (keys.IndexOf(MAG_KAT_REQUIRED_KEY) > -1);
end;

{*
  Event when the backwards radio button is selected
  @param Sender The object which sent the event
  }
procedure TfrmMagKat.rbBackwardsClick(Sender: TObject);
begin
  pgOptions.ActivePageIndex := 0;
  mnuProcessMagneticBackwards.Checked := true;
end;

{*
  Event when the forwards radio button is selected
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.rbForwardsClick(Sender: TObject);
begin
  pgOptions.ActivePageIndex := 0;
  mnuProcessMagneticForwards.Checked := true;
end;

{*
  Menu event for process range start
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessRangeStartClick(Sender: TObject);
begin
  pgOptions.ActivePageIndex := 2;
  btnProcessRangeClick(self);
end;

{*
  Menu event for process range stop
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessRangeStopClick(Sender: TObject);
begin
  pgOptions.ActivePageIndex := 2;
  btnProcessRangeStopClick(self);
end;

{*
  Menu event for process platter stop
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessPlatterStartClick(Sender: TObject);
begin
  pgOptions.ActivePageIndex := 1;
  btnProcessPlatterClick(self);
end;

{*
  menu event for process platter stop event
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessPlatterStopClick(Sender: TObject);
begin
  pgOptions.ActivePageIndex := 1;
  btnStopProcessPlatterClick(self);
end;

{*
  Button event when the process platter button is clicked
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.btnProcessPlatterClick(Sender: TObject);
var
  platter : TMagKatPlatter;
  dlgResult : integer;
begin
  if tvJukebox.Selected = nil then
    exit;
  if tvJukebox.Selected.Data = nil then
  begin
    ProcessPlatterGroup();
  end
  else
  begin
    platter := tvJukebox.Selected.Data;
    if (platter.PlatterStatus = Offline) or
      (platter.PlatterStatus = OfflineError) then
    begin
      dlgResult := MessageDlg('Platter status was offline, ' +
        'if this platter has not been brought back online and VistA ' +
        'updated with the new platter status, then processing will not work. ' +
        'Continue processing this platter?',mtConfirmation,
        mbYesNoCancel, -1);
      if (dlgResult = mrNo) or (dlgResult = mrCancel) then
        exit;
    end;
    pnlMessage.Caption := 'Processing platter "' + platter.PlatterDisplayName + '"';
    Cursor := crHourGlass;
    FCurrentProcessingState := MagKatProcessingJukebox;
    UpdateMenuAndButtonOptions();
    FMagKatEngine.ProcessPlatter(platter);
  end;
end;

{*
 Process a group of platters
 }
procedure TfrmMagKat.ProcessPlatterGroup();
var
  list : TList;
  platter : TMagKatPlatter;
  node : TTreeNode;
  i : integer;
begin
  if tvJukebox.Selected = nil then
    exit;
  node := tvJukebox.Selected;
  if not node.HasChildren then
    exit;

  list := TList.Create();
  for i := 0 to node.Count - 1 do
  begin
    if node.Item[i].Data <> nil then
    begin
      platter := node.Item[i].Data;
      list.Add(platter);
    end;
  end;
  pnlMessage.Caption := 'Processing platter group';
  Cursor := crHourGlass;
  FCurrentProcessingState := MagKatProcessingJukebox;
  UpdateMenuAndButtonOptions();
  FMagKatEngine.ProcessPlatterList(list);

end;

{*
  Event occurs when MagKat engine updates the processing status of a platter
  @param Sender The object which sent the event
  @param Platter The platter that is being processed
  @param Processed the number of files processed
  @param failed The number of files failed processing
  @param total The total number of files that exist on the platter
 }
procedure TfrmMagKat.MagKatEnginePlatterProcessingUpdateEvent(Sender : TObject;
  Platter : TMagKatPlatter; processed, failed, total : integer);
begin
  UpdatePlatterProcessingStatusDisplay(platter, processed, failed, total, true);
end;

procedure TfrmMagKat.UpdatePlatterProcessingStatusDisplay(Platter : TMagKatPlatter;
  processed, failed, total : integer; UpdateSliderPosition : boolean);
begin
  if pbPlatterProgress.Max <> total then
    pbPlatterProgress.Max := total;
  if UpdateSliderPosition then
    pbPlatterProgress.Position := processed
  else
    pbPlatterProgress.Position := 0;
  lblPlatterFailedFiles.Caption := inttostr(failed);
  lblPlatterCount.Caption := inttostr(processed) + ' of ' + inttostr(total);
  lblPlatterName.Caption := platter.PlatterName;
  lblPlatterSerial.Caption := platter.PlatterSerialNumber;
end;

{*
  menu event occurs when jukebox process platter is selected
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuJukeboxProcessPlatterClick(Sender: TObject);
begin
  btnProcessPlatterClick(self);
end;

{*
  menu event occurs when process platter is selected
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuJukeboxProcessPlattersClick(Sender: TObject);
begin
  ProcessPlatterGroup();
end;

{*
  Event occurs when MagKat updates the status of a platter
  @param Sender The object which sent the event
  @param Platter The platter with a new status to update
 }
procedure TfrmMagKat.MagKatPlatterStatusUpdateUpdateEvent(Sender : TObject;
  Platter : TMagKatPlatter);
begin
  UpdatePlatter(platter);
end;

{*
 Update a platter on the jukebox tree
 @param Platter The updated details of the platter
 }
procedure TfrmMagKat.UpdatePlatter(Platter : TMagKatPlatter);
var
 i : integer;
 plat : TMagKatPlatter;
 node, newParentNode : TTreeNode;
begin
  for i := 0 to tvJukebox.Items.Count - 1 do
  begin
    node := tvJukebox.Items[i];
    if node.Data <> nil then
    begin
      plat := node.Data;
      if (plat.PlatterName = platter.PlatterName) and
        (plat.PlatterSerialNumber = platter.PlatterSerialNumber) then
      begin
      {
        // no need to set these values since passed in actual node (pointers stupid)
        plat.TxtFilesOnPlatter := platter.TxtFilesOnPlatter;
        plat.TxtFilesProcessed := platter.TxtFilesProcessed;
        if plat.PlatterStatus = platter.PlatterStatus then
          exit;
        }
        FMagKatJukeboxFileEngine.PlattersUpdated := true;
        if platter.PlatterStatus = Online then
          newParentNode := FOnlineNode
        else if platter.PlatterStatus = Offline then
          newParentNode := FOfflineNode
        else if platter.PlatterStatus = Processed then
          newParentNode := FProcessedNode
        else if platter.PlatterStatus = OfflineError then
          newParentNode := FOfflineErrorNode
        else if platter.PlatterStatus = OnlineFailedProcess then
          newParentNode := FOnlineFailedProcessNode;
        node.MoveTo(newParentNode, naAddChild);
        setPlatterIcon(plat, node);
        exit;
      end;
    end;
  end;
end;

{*
  Set the icon for the platter based on the platter status
  @param Platter Platter with updated status
  @PlatterNode the Node on the tree to update with the correct icon based
  on the platter
 }
procedure TfrmMagKat.setPlatterIcon(Platter : TMagKatPlatter;
  PlatterNode : TTreeNode);
begin
  if platter.PlatterStatus = Online then
    platterNode.ImageIndex := 0
  else if platter.PlatterStatus = Offline then
    platterNode.ImageIndex := 1
  else if platter.PlatterStatus = OfflineError then
  begin
    platternode.ImageIndex := 6;
  end
  else if platter.PlatterStatus = Processed then
  begin
    if platter.FailedTxtFiles > 0 then
      platterNode.ImageIndex := 3
    else
      platterNode.ImageIndex := 2;
  end
  else if platter.PlatterStatus = OnlineFailedProcess then
  begin
    platternode.ImageIndex := 5;
  end;

  if platter.IOErrors > 0 then
    PlatterNode.Text := platter.PlatterDisplayName + ' [I/O Errors]';
  platterNode.SelectedIndex := PlatterNode.ImageIndex;
  tvJukebox.Repaint; // repaint the tree so the icon gets updated properly (stupid Delphi)
end;

{*
  Menu event for when jukebox view platter report is selected
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuJukeboxViewPlatterReportClick(Sender: TObject);
var
  platter : TMagKatPlatter;
  PlatterReport : TStrings;
begin
  if tvJukebox.Selected = nil then
    exit;
  if tvJukebox.Selected.Data = nil then
    exit;
  platter := tvJukebox.Selected.Data;
  PlatterReport := FMagKatJukeboxFileEngine.getPlatterReport(platter);
  if PlatterReport = nil then
  begin
    MessageDlg('No report was found for platter ' + platter.PlatterDisplayName
      + ')', mtInformation, TOKButtonOnly, -1);
    exit;
  end;
  // display platter report
  Cursor := crHourGlass;
  frmPlatterReport.ShowPlatterReport(platter, PlatterReport);
end;

{*
  Menu event for when process platter report menu is selected
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessPlatterReportClick(Sender: TObject);
begin
  mnuJukeboxViewPlatterReportClick(self);
end;

{*
  Jukebox tree event for when the selected node changes
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.tvJukeboxChange(Sender: TObject; Node: TTreeNode);
var
  platter : TMagKatPlatter;
begin
  if tvJukebox.Selected <> nil then
  begin
    if tvJukebox.Selected.Data <> nil then
    begin
      platter := tvJukebox.Selected.Data;
      lblPlatterName.Caption := platter.PlatterName;
      lblPlatterSerial.Caption := platter.PlatterSerialNumber;
      lblPlatterFailedFiles.Caption := inttostr(platter.FailedTxtFiles);
      UpdatePlatterProcessingStatusDisplay(platter, platter.TxtFilesProcessed,
        platter.FailedTxtFiles, platter.TxtFilesOnPlatter, false);
      UpdateMenuAndButtonOptions();
      mnuProcessPlatterReport.Visible := true;
      mnuProcessPlatterMarkProcessed.Visible := true;
      if IsSelectedPlatterProcessed() then
        mnuProcessPlatterMarkProcessed.Enabled := false
      else
        mnuProcessPlatterMarkProcessed.Enabled := true;
    end
    else
    begin
      mnuProcessPlatterReport.Visible := false;
      mnuProcessPlatterMarkProcessed.Visible := false;
      lblPlatterName.Caption := '';
      lblPlatterSerial.Caption := '';
      lblPlatterFailedFiles.Caption := '';
      pbPlatterProgress.Position := 0;
      lblPlatterCount.Caption := '';
    end;
  end
  else
  begin
    mnuProcessPlatterReport.Visible := false;
    mnuProcessPlatterMarkProcessed.Visible := false;
  end;
end;

{*
  Menu event for when the user wants to mark a platter as processed
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuJukeboxMarkPlatterProcessedClick(Sender: TObject);
var
  platter : TMagKatPlatter;
  dialogResult : integer;
begin
  if tvJukebox.Selected = nil then
    exit;
  if tvJukebox.Selected.Data = nil then
    exit;
  platter := tvJukebox.Selected.Data;

  dialogResult := MessageDlg('Are you sure you want to set the platter [' +
    platter.PlatterDisplayName + '] to processed?', mtConfirmation, mbYesNoCancel, -1);
  if dialogResult = mrYes then
  begin
    platter.PlatterStatus := Processed;
    // JMW 11/18/2008 - update the platter status in the update file
    FMagKatJukeboxFileEngine.writePlattertoFile(platter);
    updatePlatter(platter);
  end;
end;

{*
  Menu event for when the user wants to mark a platter as processed
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessPlatterMarkProcessedClick(Sender: TObject);
begin
  mnuJukeboxMarkPlatterProcessedClick(self);
end;

{*
  Determines if the currently selected platter has been processed. If no
  platter is selected, this returns false.
  @Return True if the current platter has been processed, false otherwise
 }
function TfrmMagKat.IsSelectedPlatterProcessed() : boolean;
var
  platter : TMagKatPlatter;
begin
  result := false;
  if tvJukebox.Selected = nil then
    exit;
  if tvJukebox.Selected.Data = nil then
    exit;
  platter := tvJukebox.Selected.Data;
  if platter = nil then
    exit;
  if platter.PlatterStatus = Processed then
    result := true;
end;

{*
  Presents a dialog for the user to enter the database they wish to connect to.
  @Return True if the user selected a database and it was written to the ini file, false if the user did not select a DB
 }
function TfrmMagKat.SelectVistaDB() : boolean;
var
  dbSelect : TfrmSelectDB;
begin
  result := false;
  dbSelect := TfrmSelectDB.Create(self);
  if dbSelect.SelectDb(FDefaultLocalVista, FDefaultLocalVistaPort) = mrOk then
  begin
    FDefaultLocalVista := dbSelect.Server;
    FDefaultLocalVistaPort := inttostr(dbSelect.Port);
    result := true;
    FMagKatIni.WriteString('MagKatSettings','Local VistA',FDefaultLocalVista);
    FMagKatIni.WriteString('MagKatSettings','Local VistA port',FDefaultLocalVistaPort);
  end
  else
  begin
    pnlMessage.Caption := 'User cancelled VistA database selection';
    result := false;
  end;
  if dbSelect <> nil then
    FreeAndNil(dbselect);
end;

{*
  Menu event for when the user wants to configure the selected database.
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuFileConfigureServerClick(Sender: TObject);
begin
  SelectVistaDB;
end;

{*
  Menu event for when the user attempts to proceed with platter processing
    without already having done the the magnetic processing.
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.mnuProcessAllowJukeboxProcessingWithoutMagneticClick(
  Sender: TObject);
var
  dialogResult : integer;
begin

  dialogResult := MessageDlg('Are you sure you want to process jukebox platters ' +
    'before you have completed processing the images stored on magnetic storage?' +
    #13 + 'You should only skip magnetic processing if another site has ' +
    'processed your site''s magnetic storage, and if the log files generated ' +
    'by the other site''s processing are available.' + #13 + 'Do you ' +
    'wish to continue?', mtConfirmation, mbYesNoCancel, -1);
  if dialogResult = mrYes then
  begin
    FMagneticProcessingComplete := true;
    UpdateMenuAndButtonOptions();
  end;

end;

{*
  Event for when the user changes the selected tab
  @param Sender The object which sent the event
 }
procedure TfrmMagKat.pgOptionsChange(Sender: TObject);
begin
  // if on the jukebox tab
  if pgOptions.ActivePageIndex = 1 then
  begin
    if not pnlHideJukebox.Visible then
    begin
      if isNoJukeboxPlatters() then
      begin
        MessageDlg('No jukebox platters found.  Be sure you have copied the MagDexter output to the ''' +
          FMagKatJukeboxFileEngine.PlatterDirectory + ''' directory on this machine.',
          mtWarning, TOKButtonOnly, -1);
      end;
    end;
  end;
end;

{*
  Determines if there are no jukebox platters in any child node
  @Return True if there are no nodes, false if there is at least 1 node.
 }
function TfrmMagKat.isNoJukeboxPlatters() : boolean;
begin
  result := false;
  if FOnlineNode.Count > 0 then
    exit;
  if FOfflineNode.Count > 0 then
    exit;
  if FProcessedNode.Count > 0 then
    exit;
  if FOfflineErrorNode.Count > 0 then
    exit;
  if FOnlineFailedProcessNode.Count > 0 then
    exit;
  result := true;
end;

end.
