unit fMagSelectDb;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, cMagKatUtils;

type
  TfrmSelectDB = class(TForm)
    edtServer: TLabeledEdit;
    edtPort: TLabeledEdit;
    Label1: TLabel;
    btnOK: TButton;
    btnCancel: TButton;
    procedure btnOKClick(Sender: TObject);
  private
    FServer : String;
    FPort : integer;
    { Private declarations }
  public
    { Public declarations }
    function SelectDb(Server, Port : String) : TModalResult;

    property Server : String read FServer;
    property Port : integer read FPort;
  end;

implementation

{$R *.dfm}

function TfrmSelectDB.SelectDb(Server, Port : String) : TModalResult;
begin
  FServer := '';
  FPort := 0;
  edtServer.Text := server;
  edtPort.Text := port;

  ShowModal;
  result := ModalResult;
end;

procedure TfrmSelectDB.btnOKClick(Sender: TObject);
begin
  FPort := -1;
  FServer := '';
  try
    FPort := strtoint(edtPort.Text);
  except
    on E : Exception do
    begin
      MessageDlg('Server port must be an integer value',
        mtError, TOKButtonOnly, -1);
      ModalResult := mrNone;
      edtPort.SetFocus;
      exit;
    end;
  end;
  FServer := edtServer.Text;
  if FServer = '' then
  begin
    MessageDlg('The server name cannot be empty',
        mtError, TOKButtonOnly, -1);
    ModalResult := mrNone;
    edtServer.SetFocus;
    exit;
  end;
  if FPort <= 0 then
  begin
    MessageDlg('The server port must be greater than 0',
        mtError, TOKButtonOnly, -1);
    ModalResult := mrNone;
    edtPort.SetFocus;
    exit;
  end;
end;

end.
