program MagUtility;

uses
  Forms,
  TConfiguratorUnit,
  SysUtils,
  uMagUtility in 'uMagUtility.pas' {fMagUtility},
  cMagUtilityBroker in 'cMagUtilityBroker.pas',
  cMagUtilityUtils in 'cMagUtilityUtils.pas',
  MagFileVersion in 'MagFileVersion.pas',
  fMagCalendar in 'fMagCalendar.pas' {frmMagCalendar},
  ads_DlgLU in 'ads_DlgLU.pas',
  crc32 in 'crc32.pas',
  FMagAbout in 'fMagAbout.pas' {frmAbout},
  Fmxutils in 'Fmxutils.pas';

{$R *.res}
var
  /// holds the current directory to write log files to
  logsDir : string;
  logfName : string;
  EurekaLog: string;
begin
  Application.Initialize;
  logsDir := cMagUtilityUtils.GetAppPath() + '\logs';
  if not DirectoryExists(logsDir) then
  begin
    ForceDirectories(logsDir);
  end;
  EurekaLog:= logsDir+'MagUtility.txt';
  //{ $ IFDEF EUREKALOG}
  //CurrentEurekaLogOptions.OutputPath := logsDir;
  //CurrentEurekaLogOptions.OutputFile(EurekaLog);
  //{ $ ENDIF}
  logfName := logsDir + '\MagUtilityInfo.log';
  cMagUtilityUtils.CreateIfNeeded(logfName);
  logfName := logsDir + '\MagUtilityDebug.log';
  cMagUtilityUtils.CreateIfNeeded(logfName);
  TConfiguratorUnit.doPropertiesConfiguration(ExtractFileDir(Application.ExeName)+ '\logging.properties');
  Application.Title := 'MagUtility';
  Application.CreateForm(TfMagUtility, fMagUtility);
  Application.CreateForm(TfrmMagCalendar, frmMagCalendar);
  Application.CreateForm(TfrmAbout, frmAbout);
  Application.Run;
end.
