unit fMagCalendar;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TfrmMagCalendar = class(TForm)
    pnlCalBase: TPanel;
    pnlCalBot: TPanel;
    pnlCalTop: TPanel;
    MonthCalendar: TMonthCalendar;
    pnlButtons: TPanel;
    btnOk: TBitBtn;
    btnCancel: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    procedure SetSuccess(const Value: Boolean);
  protected
    FSuccess: Boolean;
    function GetDate: TDateTime;
    procedure SetDate(const Value: TDateTime);
    function GetSuccess: Boolean;
  public
    Class Function Execute(var Default: TDateTime): Boolean;
  published
    property Date: TDateTime Read GetDate Write SetDate;
    property Success: Boolean Read GetSuccess Write SetSuccess;
  end;

var
  frmMagCalendar: TfrmMagCalendar;

implementation

{$R *.dfm}

{ TfrmMagCalendar }


function TfrmMagCalendar.GetDate: TDateTime;
begin
  Result:=MonthCalendar.Date;
end;

function TfrmMagCalendar.GetSuccess: Boolean;
begin
  Result:=FSuccess;
end;

procedure TfrmMagCalendar.SetDate(const Value: TDateTime);
begin
  MonthCalendar.Date:=Date;
end;

procedure TfrmMagCalendar.SetSuccess(const Value: Boolean);
begin
  FSuccess:=Value;
end;

procedure TfrmMagCalendar.FormCreate(Sender: TObject);
begin
  FSuccess:=False;
end;

procedure TfrmMagCalendar.FormActivate(Sender: TObject);
begin
  FSuccess:=False;
end;

procedure TfrmMagCalendar.btnOkClick(Sender: TObject);
begin
  Date:=MonthCalendar.Date;
  FSuccess:=True;
end;

procedure TfrmMagCalendar.btnCancelClick(Sender: TObject);
begin
  Date:=0;
  FSuccess:=False;
end;

class function TfrmMagCalendar.Execute(var Default: TDateTime): Boolean;
Var
  f: TfrmMagCalendar;
begin
  Result:=False;
  f:=TfrmMagCalendar.Create(nil);
  Try
    If Default=0 Then
    Begin
      f.Date:=now();
    End
    Else
    Begin
      Try
        f.Date:=Default;
        f.MonthCalendar.Date:=Default;
      Except
        f.Date:=now();
      End;
    End;
    f.ShowModal();
    If f.Success Then
    Begin
      Default:=f.Date;
      Result:=TRue;
    End
    Else
    Begin
      Default:=0;
    End;
  Finally
    FreeAndNil(f);
  End;
end;

end.
