unit Telabout;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons,Sysutils, ExtCtrls,fmxutils, ComCtrls,Trpcb,Dialogs,DateUtils,
  uMagCRC32;

type
  TTELABOUTF = class(TForm)
    Panel1: TPanel;
    OKButton: TBitBtn;
    ProgramIcon: TImage;
    Version: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    filename: TLabel;
    filesize: TLabel;
    filedate: TLabel;
    lbAlign: TLabel;
    lblVersionValue: TLabel;
    lvInstalls: TListView;
    Label5: TLabel;
    AltApp: TLabel;
    AltAppVer: TLabel;
    lblCRC: TLabel;
    lblCRCValue: TLabel;
    mmoAccess: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure lvColumnClick(Sender: TObject;
        Column: TListColumn);
    procedure lvCompare(Sender: TObject; Item1,
      Item2: TListItem; Data: Integer; var Compare: Integer);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TELABOUTF: TTELABOUTF;
  InstallString : TStringlist;
  ColumnToSort: Integer;
  ColA : Array[0..250] of Integer;
implementation
uses magbut,magpurge1;
{$R *.DFM}

procedure TTELABOUTF.FormCreate(Sender: TObject);
var i,CRC: integer;
stream : TmemoryStream;
 UAccess: string;

begin
filename.caption := application.exename;
filesize.caption := inttostr((getfilesize(Application.exename) div 1024)+1)+ ' KB';
filedate.caption := formatdatetime('mm/dd/yy  h:nn  am/pm',filedatetime(Application.exename));
lblVersionValue.Caption := GetAppVer(Application.ExeName);
AltApp.Caption := 'MagUtility.exe' ;
AltAppVer.Caption := GetAppVer(ExtractFilePath(Application.exename)+'MagUtility.exe');
Stream:=TMemoryStream.Create;
Stream.LoadFromFile(application.exename);
CRC:=GetMemoryStreamCrc32(Stream);
Stream.Free;
lblCrcValue.Caption := IntToHex(CRC,8);
clientheight := lbalign.top +lbalign.height;
clientwidth := lbalign.left+lbalign.width;
for i := 0 to lvInstalls.Columns.Count do ColA[i]:=1;
InstallString := TStringList.Create;
  with frmmagpurge.RPCBroker1 do begin
    ClearParameters := true;
    RemoteProcedure := 'MAGG INSTALL';
    try
      LSTCALL(InstallString);
    except
      On E: EBrokerError do begin
        showmessage('Help About Install report EBroker Error');
        Exit;
        end;
      On E: Exception do begin
        showmessage('Help About Install report Exception');
        exit;
        end;
      end;  //try
    end; //with yBroker
  lvUpdate(true,InstallString,lvInstalls);
end;

procedure TTELABOUTF.OKButtonClick(Sender: TObject);
begin
         ModalResult := mrOK;
end;
procedure TTELABOUTF.lvColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  ColumnToSort := Column.Index;
  ColA[ColumnToSort] := ColA[ColumnToSort]+1;
  (Sender as TCustomListView).AlphaSort;
end;

procedure TTELABOUTF.lvCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
function CompAll(Input1,Input2:string):integer;
var
  I1,I2,C1,C2: Integer;
  Date1,Date2: TDateTime;

begin
  Val(Input1,I1,C1);
  Val(Input2,I2,C2);
  if ((c1 = 0) and (c2 = 0)) then begin
    if I1 > I2 then result := I1 - I2;
    if I1 < I2 then result := -(I2 - I1);
    if I1 = I2 then result := 0;
    exit;
    end;
  if (TryStrToDate(Input1,Date1) or
    TryStrToDate(Input2,Date2)) then begin
    TryStrToDate(Input2,Date2);
    if Date1 > Date2 then result := 1;
    if Date1 < Date2 then result := -1;
    if Date1 = Date2 then result := 0;
    exit;
    end;
  result := CompareText(Input1,Input2);
end;
var IX: integer;
begin
  if ColumnToSort = 0 then
    Compare := CompAll(Item1.Caption,Item2.Caption)
  else begin
   ix := ColumnToSort - 1;
   Compare := CompAll(Item1.SubItems[ix],Item2.SubItems[ix]);
   end;
   if ColA[ColumnToSort] mod 2 = 1 then begin
     case Compare of
       0:;
       1: Compare := -1;
       else Compare := 1;
       end;
     end;
end;



end.

